﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows.Forms;
using Microsoft.VisualBasic.CompilerServices;
using ThumbServer.My;

namespace ThumbServer
{
	// Token: 0x02000009 RID: 9
	[StandardModule]
	internal sealed class RenderServer
	{
		// Token: 0x06000021 RID: 33 RVA: 0x00193FE0 File Offset: 0x001923E0
		public static Image ResizeImage(Image image, Size size, bool preserveAspectRatio = true)
		{
			checked
			{
				int width2;
				int height2;
				if (preserveAspectRatio)
				{
					int width = image.Width;
					int height = image.Height;
					float num = (float)size.Width / (float)width;
					float num2 = (float)size.Height / (float)height;
					float num3 = (num2 < num) ? num2 : num;
					width2 = (int)Math.Round((double)(unchecked((float)width * num3)));
					height2 = (int)Math.Round((double)(unchecked((float)height * num3)));
				}
				else
				{
					width2 = size.Width;
					height2 = size.Height;
				}
				Image image2 = new Bitmap(width2, height2);
				Graphics graphics = Graphics.FromImage(image2);
				try
				{
					graphics.InterpolationMode = InterpolationMode.HighQualityBicubic;
					graphics.DrawImage(image, 0, 0, width2, height2);
				}
				finally
				{
					bool flag = graphics != null;
					if (flag)
					{
						((IDisposable)graphics).Dispose();
					}
				}
				return image2;
			}
		}

		// Token: 0x06000022 RID: 34 RVA: 0x001940BC File Offset: 0x001924BC
		[STAThread]
		[MethodImpl(MethodImplOptions.NoInlining | MethodImplOptions.NoOptimization)]
		public static void Main()
		{
			string productVersion = Application.ProductVersion;
			Console.Title = "GoodBlox Render v" + productVersion + " (RevisedOTDbg 1.5.6.2)";
			RenderServer.writeLine("GoodBlox Render v" + productVersion + ":tm:");
			string text = Application.ExecutablePath.Replace(Application.StartupPath + "\\", null);
			bool flag = File.Exists("update");
			if (flag)
			{
				string text2 = DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt");
				RenderServer.writeLine("Finishing update..");
				File.Delete("tmbsNew.exe");
				File.Delete("update");
			}
			flag = text.Contains("tmbsNew");
			if (flag)
			{
				RenderServer.writeLine("Updating..");
				flag = !Directory.Exists("oldVersions");
				if (flag)
				{
					Directory.CreateDirectory("oldVersions");
				}
				string fileName = Application.StartupPath + "\\ThumbServer.exe";
				FileVersionInfo versionInfo = FileVersionInfo.GetVersionInfo(fileName);
				string fileVersion = versionInfo.FileVersion;
				File.Move(Application.StartupPath + "\\ThumbServer.exe", Application.StartupPath + "\\oldVersions\\ThumbServer" + fileVersion + ".exe");
				File.Copy("tmbsNew.exe", "ThumbServer.exe");
				File.Create("update");
				Process.Start("ThumbServer.exe");
				ProjectData.EndApp();
			}
			RenderServer.writeLine("Loading settings..");
			flag = !File.Exists("settings.ini");
			if (flag)
			{
				RenderServer.writeLine("settings.ini does not exist. Please copy format.ini, edit it appropriately and try again.");
				RenderServer.writeLine("Press any key to exit.");
				Console.ReadKey();
				ProjectData.EndApp();
			}
			string text3 = Application.StartupPath + "\\avatarRenders\\";
			string text4 = Application.StartupPath + "\\hatRenders\\";
			string text5 = Application.StartupPath + "\\tshirtRenders\\";
			string text6 = Application.StartupPath + "\\modelRenders\\";
			string path = Application.StartupPath + "\\placeRenders\\";
			flag = !Directory.Exists(text3);
			if (flag)
			{
				Directory.CreateDirectory(text3);
			}
			flag = !Directory.Exists(text4);
			if (flag)
			{
				Directory.CreateDirectory(text4);
			}
			flag = !Directory.Exists(text5);
			if (flag)
			{
				Directory.CreateDirectory(text5);
			}
			flag = !Directory.Exists(text6);
			if (flag)
			{
				Directory.CreateDirectory(text6);
			}
			flag = !Directory.Exists(path);
			if (flag)
			{
				Directory.CreateDirectory(path);
			}
			int num = 0;
			RichTextBox richTextBox = new RichTextBox();
			richTextBox.Text = File.ReadAllText("settings.ini");
			Array array = new string[]
			{
				"waitToCapture",
				"waitforNewCheck",
				"Shard",
				"placeCaptureWait",
				"baseUrl",
				"storUrl",
				"storUsn",
				"storPsw",
				"MaxEmptyCalls",
				"AdditionalWarmBootTimes",
				"CoolBootTime",
				"Password",
				"ConsoleLines"
			};
			Dictionary<string, string> dictionary = new Dictionary<string, string>();
			dictionary["waitToCapture"] = "12500";
			dictionary["waitforNewCheck"] = "1000";
			dictionary["Shard"] = "";
			dictionary["placeCaptureWait"] = "15000";
			dictionary["baseUrl"] = "";
			dictionary["storUrl"] = "";
			dictionary["storUsn"] = "";
			dictionary["storPsw"] = "";
			dictionary["MaxEmptyCalls"] = "30";
			dictionary["AdditionalWarmBootTimes"] = "0";
			dictionary["CoolBootTime"] = "7500";
			dictionary["Password"] = "";
			dictionary["ConsoleLines"] = "1000";
			foreach (string text7 in richTextBox.Lines)
			{
				try
				{
					foreach (object value in array)
					{
						string text8 = Conversions.ToString(value);
						flag = text7.StartsWith(text8 + "=");
						if (flag)
						{
							dictionary[text8] = text7.Replace(text8 + "=", null);
						}
					}
				}
				finally
				{
					IEnumerator enumerator;
					flag = (enumerator is IDisposable);
					if (flag)
					{
						(enumerator as IDisposable).Dispose();
					}
				}
			}
			flag = Versioned.IsNumeric(dictionary["waitToCapture"]);
			int num2;
			if (flag)
			{
				num2 = Conversions.ToInteger(dictionary["waitToCapture"]);
			}
			else
			{
				RenderServer.kill("waitToCapture number is not valid. Check your settings file and try again.");
			}
			flag = Versioned.IsNumeric(dictionary["waitforNewCheck"]);
			int millisecondsTimeout;
			if (flag)
			{
				millisecondsTimeout = Conversions.ToInteger(dictionary["waitforNewCheck"]);
			}
			else
			{
				RenderServer.kill("waitforNewCheck number is not valid. Check your settings file and try again.");
			}
			flag = Versioned.IsNumeric(dictionary["placeCaptureWait"]);
			int num3;
			if (flag)
			{
				num3 = Conversions.ToInteger(dictionary["placeCaptureWait"]);
			}
			else
			{
				RenderServer.kill("placeCaptureWait number is not valid. Check your settings file and try again.");
			}
			flag = Versioned.IsNumeric(dictionary["MaxEmptyCalls"]);
			int num4;
			if (flag)
			{
				num4 = Conversions.ToInteger(dictionary["MaxEmptyCalls"]);
			}
			else
			{
				RenderServer.kill("MaxEmptyCalls number is not valid. Check your settings file and try again.");
			}
			flag = Versioned.IsNumeric(dictionary["AdditionalWarmBootTimes"]);
			int num5;
			if (flag)
			{
				num5 = Conversions.ToInteger(dictionary["AdditionalWarmBootTimes"]);
			}
			else
			{
				RenderServer.kill("AdditionalWarmBootTimes number is not valid. Check your settings file and try again.");
			}
			flag = Versioned.IsNumeric(dictionary["CoolBootTime"]);
			int num6;
			if (flag)
			{
				num6 = Conversions.ToInteger(dictionary["CoolBootTime"]);
			}
			else
			{
				RenderServer.kill("CoolBootTime number is not valid. Check your settings file and try again.");
			}
			flag = Versioned.IsNumeric(dictionary["ConsoleLines"]);
			if (flag)
			{
				RenderServer.consoleLines = Conversions.ToInteger(dictionary["ConsoleLines"]);
			}
			else
			{
				RenderServer.kill("ConsoleLines number is not valid. Check your settings file and try again.");
			}
			flag = (Operators.CompareString(dictionary["Shard"], "", false) == 0 | Operators.CompareString(dictionary["baseUrl"], "", false) == 0 | Operators.CompareString(dictionary["storUrl"], "", false) == 0 | Operators.CompareString(dictionary["storUsn"], "", false) == 0 | Operators.CompareString(dictionary["storPsw"], "", false) == 0 | Operators.CompareString(dictionary["Password"], "", false) == 0);
			if (flag)
			{
				RenderServer.writeLine("The following variables cannot be empty:");
				RenderServer.writeLine("Shard (" + dictionary["Shard"] + ")");
				RenderServer.writeLine("baseUrl (" + dictionary["baseUrl"] + ")");
				RenderServer.writeLine("storUrl (" + dictionary["storUrl"] + ")");
				RenderServer.writeLine("storUsn (" + dictionary["storUsn"] + ")");
				RenderServer.writeLine("storPsw (" + dictionary["storPsw"] + ")");
				RenderServer.writeLine("Password (" + dictionary["Password"] + ")");
				RenderServer.kill("Make sure they have all been entered correctly and try again.");
			}
			flag = Versioned.IsNumeric(dictionary["Shard"]);
			int value2;
			if (flag)
			{
				value2 = Conversions.ToInteger(dictionary["Shard"]);
			}
			else
			{
				RenderServer.kill("Shard number is not valid. Check your settings file and try again.");
			}
			flag = (dictionary["baseUrl"].EndsWith("/") | dictionary["storUrl"].EndsWith("/"));
			if (flag)
			{
				RenderServer.kill("Please remove the / from all urls in your settings file, and try again.");
			}
			string text9 = dictionary["baseUrl"];
			string str = dictionary["storUrl"];
			string userName;
			string password;
			try
			{
				flag = File.Exists("inttst.tmp");
				if (flag)
				{
					File.Delete("inttst.tmp");
				}
				MyProject.Computer.Network.DownloadFile(dictionary["storUrl"], "inttst.tmp", dictionary["storUsn"], dictionary["storPsw"]);
				str = dictionary["storUrl"];
				userName = dictionary["storUsn"];
				password = dictionary["storPsw"];
				try
				{
					File.Delete("inttst.tmp");
				}
				catch (Exception ex)
				{
				}
			}
			catch (Exception ex2)
			{
				try
				{
					File.Delete("inttst.tmp");
				}
				catch (Exception ex3)
				{
				}
				RenderServer.kill("The credentials for the storage server is invalid. Check them and try again.");
			}
			string text10 = dictionary["Password"];
			RenderServer.rendererLoaded = true;
			Rectangle rectangle = default(Rectangle);
			int num7 = 0;
			RenderServer.writeLine("Current shard: " + Conversions.ToString(value2));
			checked
			{
				for (;;)
				{
					RenderServer.writeLine("Cold booting the render..");
					Process process = Process.Start(Application.StartupPath + "\\Render\\GBRender.exe", "-script \"" + text9.Replace("https://", "http://") + "/goodblox/api/scripts/asset/scr.php?oid=1");
					RenderServer.writeLine("Sleeping " + Conversions.ToString((double)num6 / 1000.0) + " seconds..");
					Thread.Sleep(num6);
					RenderServer.writeLine("Killing..");
					process.Kill();
					RenderServer.writeLine("Warm booting the render..");
					Process process2 = Process.Start(Application.StartupPath + "\\Render\\GBRender.exe", "-script \"" + text9.Replace("https://", "http://") + "/goodblox/api/scripts/asset/scr.php?oid=1");
					RenderServer.writeLine("Sleeping " + Conversions.ToString((double)num6 / 1000.0) + " seconds..");
					Thread.Sleep(num6);
					RenderServer.writeLine("Killing..");
					process2.Kill();
					flag = (num5 > 0);
					if (flag)
					{
						RenderServer.writeLine("Performing additional warm boots as requested..");
						do
						{
							num++;
							RenderServer.writeLine("Additional warm boot " + Conversions.ToString(num));
							Process process3 = Process.Start(Application.StartupPath + "\\Render\\GBRender.exe", "-script \"" + text9.Replace("https://", "http://") + "/goodblox/api/scripts/asset/scr.php?oid=1");
							RenderServer.writeLine("Sleeping " + Conversions.ToString((double)num6 / 1000.0) + " seconds..");
							Thread.Sleep(num6);
							RenderServer.writeLine("Killing..");
							process3.Kill();
							flag = (num == num4 | num > num4);
						}
						while (flag);
						Console.WriteLine("Additional warm boots have been completed.");
					}
					num7 = 0;
					RenderServer.writeLine("The render should now open quickly.");
					for (;;)
					{
						RenderServer.writeLine("Fetching asset to be rendered..");
						WebClient webClient = new WebClient();
						webClient.Headers.Add("user-agent", "GoodBloxrenderv/1.0");
						try
						{
							string[] array2 = webClient.DownloadString(string.Concat(new string[]
							{
								text9,
								"/goodblox/api/scripts/render_server/?ver=",
								productVersion,
								"&shard=",
								Conversions.ToString(value2),
								"&password=",
								text10
							})).Split(new char[]
							{
								'|'
							});
							flag = (Operators.CompareString(array2[0], "update", false) == 0);
							if (flag)
							{
								RenderServer.writeLine("An update was found.");
								string text11 = array2[1];
								RenderServer.writeLine("URL: " + text11);
								flag = File.Exists("tmbsNew.exe");
								if (flag)
								{
									File.Delete("tmbsNew.exe");
								}
								RenderServer.writeLine("Deleted tmbsNew.exe");
								RenderServer.writeLine("Downloading..");
								MyProject.Computer.Network.DownloadFile(text11, Application.StartupPath + "\\tmbsNew.exe");
								RenderServer.writeLine("Starting update..");
								Process.Start(Application.StartupPath + "\\tmbsNew.exe");
								ProjectData.EndApp();
							}
							flag = (Operators.CompareString(array2[0], "nan", false) != 0);
							if (flag)
							{
								RenderServer.SetCursorPos(0, 0);
								RenderServer.writeLine("Moved cursor to 0,0");
							}
							flag = (Operators.CompareString(array2[0], "0", false) == 0);
							if (flag)
							{
								RenderServer.writeLine("Rendering avatar (userID : " + array2[2] + ")");
								int value3 = Conversions.ToInteger(array2[2]);
								string text12 = text3 + Conversions.ToString(value3) + "\\";
								flag = !Directory.Exists(text12);
								if (flag)
								{
									Directory.CreateDirectory(text12);
								}
								Process process4 = Process.Start(Application.StartupPath + "\\Render\\GBRender.exe", "-script \"" + text9.Replace("https://", "http://") + "/goodblox/api/scripts/asset/scr.php?oid=" + Conversions.ToString(value3));
								RenderServer.writeLine("Sleeping " + Conversions.ToString((double)num2 / 1000.0) + " seconds..");
								Thread.Sleep(num2);
								RenderServer.FocusWindow("Roblox - [Place1]", null);
								RenderServer.BringMainWindowToFront("Render");
								RenderServer.ImageModelServerView();
								flag = (Operators.CompareString(array2[3], "0", false) == 0);
								if (flag)
								{
									RenderServer.writeLine("Capturing (hatOn: false)");
									Bitmap bitmap = new Bitmap(746, 914);
									Bitmap bitmap2 = new Bitmap(916, 914);
									Point point = new Point(612, 101);
									Bitmap bitmap3 = new Bitmap(100, 100);
									Bitmap bitmap4 = new Bitmap(180, 220);
									Graphics graphics = Graphics.FromImage(bitmap);
									Graphics graphics2 = Graphics.FromImage(bitmap2);
									Graphics graphics3 = Graphics.FromImage(bitmap3);
									Graphics graphics4 = Graphics.FromImage(bitmap4);
									Graphics graphics5 = graphics;
									Point upperLeftSource = new Point(rectangle.Left + 602, rectangle.Top + 89);
									graphics5.CopyFromScreen(upperLeftSource, Point.Empty, bitmap.Size);
									Graphics graphics6 = graphics2;
									upperLeftSource = new Point(rectangle.Left + 512, rectangle.Top + 89);
									graphics6.CopyFromScreen(upperLeftSource, Point.Empty, bitmap2.Size);
									bitmap.MakeTransparent(Color.FromArgb(0, 255, 1));
									bitmap.MakeTransparent(Color.FromArgb(75, 254, 0));
									bitmap.MakeTransparent(Color.FromArgb(75, 255, 0));
									bitmap.MakeTransparent(Color.FromArgb(82, 255, 0));
									bitmap.MakeTransparent(Color.FromArgb(79, 254, 0));
									bitmap.MakeTransparent(Color.FromArgb(79, 255, 0));
									bitmap2.MakeTransparent(Color.FromArgb(0, 255, 1));
									bitmap2.MakeTransparent(Color.FromArgb(75, 254, 0));
									bitmap2.MakeTransparent(Color.FromArgb(75, 255, 0));
									bitmap2.MakeTransparent(Color.FromArgb(82, 255, 0));
									bitmap2.MakeTransparent(Color.FromArgb(79, 254, 0));
									RenderServer.writeLine("Saving..");
									Image image = bitmap2;
									Size size = new Size(193, 192);
									Image image2 = RenderServer.ResizeImage(image, size, true);
									graphics4.DrawImage(image2, -4, 14);
									bitmap4.Save(Conversions.ToString(value3) + ".png");
									Image image3 = bitmap2;
									size = new Size(100, 100);
									Image image4 = RenderServer.ResizeImage(image3, size, true);
									graphics3.DrawImage(image4, 1, 2);
									bitmap3.Save(Conversions.ToString(value3) + "-others.png");
								}
								else
								{
									RenderServer.writeLine("Capturing (hatOn: true)");
									Bitmap bitmap5 = new Bitmap(746, 914);
									Bitmap bitmap6 = new Bitmap(916, 914);
									Point point2 = new Point(612, 101);
									Graphics graphics7 = Graphics.FromImage(bitmap5);
									Graphics graphics8 = Graphics.FromImage(bitmap6);
									Graphics graphics9 = graphics7;
									Point upperLeftSource = new Point(rectangle.Left + 602, rectangle.Top + 89);
									graphics9.CopyFromScreen(upperLeftSource, Point.Empty, bitmap5.Size);
									Graphics graphics10 = graphics8;
									upperLeftSource = new Point(rectangle.Left + 512, rectangle.Top + 89);
									graphics10.CopyFromScreen(upperLeftSource, Point.Empty, bitmap6.Size);
									bitmap5.MakeTransparent(Color.FromArgb(0, 255, 1));
									bitmap5.MakeTransparent(Color.FromArgb(75, 254, 0));
									bitmap5.MakeTransparent(Color.FromArgb(75, 255, 0));
									bitmap5.MakeTransparent(Color.FromArgb(82, 255, 0));
									bitmap5.MakeTransparent(Color.FromArgb(79, 254, 0));
									bitmap6.MakeTransparent(Color.FromArgb(0, 255, 1));
									bitmap6.MakeTransparent(Color.FromArgb(75, 254, 0));
									bitmap6.MakeTransparent(Color.FromArgb(75, 255, 0));
									bitmap6.MakeTransparent(Color.FromArgb(82, 255, 0));
									bitmap6.MakeTransparent(Color.FromArgb(79, 254, 0));
									RenderServer.writeLine("Saving..");
									Image image5 = bitmap5;
									Size size = new Size(180, 220);
									Image image6 = RenderServer.ResizeImage(image5, size, true);
									image6.Save(text12 + Conversions.ToString(value3) + ".png");
									Image image7 = bitmap6;
									size = new Size(100, 100);
									Image image8 = RenderServer.ResizeImage(image7, size, true);
									image8.Save(text12 + Conversions.ToString(value3) + "-others.png");
								}
								process4.Kill();
								RenderServer.writeLine("Uploading..");
								FileStream fileStream = File.Open(text12 + Conversions.ToString(value3) + ".png", FileMode.Open);
								FileStream fileStream2 = File.Open(text12 + Conversions.ToString(value3) + "-others.png", FileMode.Open);
								RenderServer.UploadAsync(text9 + "/goodblox/api/scripts/render_server/uploadTheRenderersOk.php?password=1pVoBfdx3PcgGZKR&queueid=" + array2[1], fileStream, fileStream2, 0, null, null);
								fileStream.Dispose();
								fileStream2.Dispose();
								RenderServer.writeLine("Done!");
								MyProject.Computer.FileSystem.RenameFile(text12 + Conversions.ToString(value3) + ".png", Conversions.ToString(value3) + "_" + DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt") + ".png");
								MyProject.Computer.FileSystem.RenameFile(text12 + Conversions.ToString(value3) + "-others.png", Conversions.ToString(value3) + "-others_" + DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt") + ".png");
							}
							else
							{
								flag = (Operators.CompareString(array2[0], "1", false) == 0);
								if (flag)
								{
									RenderServer.writeLine("Rendering hat (hatID : " + array2[2] + ")");
									int value4 = Conversions.ToInteger(array2[2]);
									string text13 = text4 + Conversions.ToString(value4) + "\\";
									flag = !Directory.Exists(text13);
									if (flag)
									{
										Directory.CreateDirectory(text13);
									}
									RenderServer.SetCursorPos(0, 0);
									RenderServer.writeLine("Moved cursor to 0,0");
									Process process5 = Process.Start(Application.StartupPath + "\\Render\\GBRender.exe", "-script \"" + text9.Replace("https://", "http://") + "/goodblox/api/scripts/asset/scr.php?aaid=" + Conversions.ToString(value4));
									RenderServer.writeLine("Sleeping " + Conversions.ToString((double)num2 / 1000.0) + " seconds..");
									Thread.Sleep(num2);
									RenderServer.FocusWindow("Roblox - [Place1]", null);
									RenderServer.BringMainWindowToFront("Render");
									RenderServer.ImageModelServerView();
									Bitmap bitmap7 = new Bitmap(921, 921);
									Point point3 = new Point(965, 521);
									Point point4 = new Point(995, 519);
									Graphics graphics11 = Graphics.FromImage(bitmap7);
									Graphics graphics12 = graphics11;
									Point upperLeftSource = new Point(rectangle.Left + 500, rectangle.Top + 85);
									graphics12.CopyFromScreen(upperLeftSource, Point.Empty, bitmap7.Size);
									bitmap7.MakeTransparent(Color.FromArgb(75, 254, 0));
									bitmap7.MakeTransparent(Color.FromArgb(75, 255, 0));
									bitmap7.MakeTransparent(Color.FromArgb(82, 255, 0));
									bitmap7.MakeTransparent(Color.FromArgb(0, 255, 1));
									Image image9 = bitmap7;
									Size size = new Size(120, 120);
									Image image10 = RenderServer.ResizeImage(image9, size, true);
									image10.Save(text13 + Conversions.ToString(value4) + ".png");
									Image image11 = bitmap7;
									size = new Size(250, 250);
									Image image12 = RenderServer.ResizeImage(image11, size, true);
									image12.Save(text13 + Conversions.ToString(value4) + "-catpage.png");
									process5.Kill();
									RenderServer.writeLine("Uploading..");
									FileStream fileStream3 = File.Open(text13 + Conversions.ToString(value4) + ".png", FileMode.Open);
									FileStream fileStream4 = File.Open(text13 + Conversions.ToString(value4) + "-catpage.png", FileMode.Open);
									RenderServer.UploadAsync(text9 + "/goodblox/api/scripts/render_server/uploadTheRenderersOk.php?password=1pVoBfdx3PcgGZKR&queueid=" + array2[1], fileStream3, fileStream4, 1, null, null);
									fileStream3.Dispose();
									fileStream4.Dispose();
									RenderServer.writeLine("Done!");
									MyProject.Computer.FileSystem.RenameFile(text13 + Conversions.ToString(value4) + ".png", Conversions.ToString(value4) + "_" + DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt") + ".png");
									MyProject.Computer.FileSystem.RenameFile(text13 + Conversions.ToString(value4) + "-catpage.png", Conversions.ToString(value4) + "-others_" + DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt") + ".png");
								}
								else
								{
									flag = (Operators.CompareString(array2[0], "2", false) == 0);
									if (flag)
									{
										RenderServer.writeLine("Rendering shirt (shirtID : " + array2[2] + ")");
										string text14 = array2[2];
										string text15 = text5 + text14 + "\\";
										flag = !Directory.Exists(text15);
										if (flag)
										{
											Directory.CreateDirectory(text15);
										}
										string str2 = array2[3];
										RenderServer.writeLine("TextureID " + array2[3]);
										Image image13 = new Bitmap(250, 250);
										image13 = Image.FromFile("TShirt.Png");
										Graphics graphics13 = Graphics.FromImage(image13);
										WebClient webClient2 = new WebClient();
										RenderServer.writeLine("Downloading shirt image..");
										Bitmap bitmap8 = (Bitmap)Image.FromStream(new MemoryStream(webClient2.DownloadData(text9 + "/goodblox/api/scripts/asset/?id=" + str2)));
										RenderServer.writeLine("Resizing image..");
										Image image14 = bitmap8;
										Size size = new Size(128, 128);
										Image image15 = RenderServer.ResizeImage(image14, size, true);
										RenderServer.writeLine("Drawing..");
										graphics13.DrawImage(image15, 57, 46);
										RenderServer.writeLine("Saving..");
										image13.Save(text15 + text14 + ".png", ImageFormat.Png);
										RenderServer.writeLine("Uploading..");
										MyProject.Computer.Network.UploadFile(text15 + text14 + ".png", text9 + "/goodblox/api/scripts/render_server/uploadTheRenderersOk.php?password=1pVoBfdx3PcgGZKR&queueid=" + array2[1]);
										RenderServer.writeLine("Done!");
										MyProject.Computer.FileSystem.RenameFile(text15 + text14 + ".png", text14 + "_" + DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt") + ".png");
									}
									else
									{
										flag = (Operators.CompareString(array2[0], "3", false) == 0);
										if (flag)
										{
											RenderServer.writeLine("Rendering model (mID : " + array2[2] + ")");
											int value5 = Conversions.ToInteger(array2[2]);
											string text16 = text6 + Conversions.ToString(value5) + "\\";
											flag = !Directory.Exists(text16);
											if (flag)
											{
												Directory.CreateDirectory(text16);
											}
											Process process6 = Process.Start(Application.StartupPath + "\\Render\\GBRender.exe", "-script \"" + text9.Replace("https://", "http://") + "/goodblox/api/scripts/asset/scr.php?aaid=" + Conversions.ToString(value5));
											RenderServer.writeLine("Sleeping " + Conversions.ToString((double)num2 / 1000.0) + " seconds..");
											Thread.Sleep(num2);
											RenderServer.FocusWindow("Roblox - [Place1]", null);
											RenderServer.BringMainWindowToFront("Render");
											RenderServer.ImageModelServerView();
											RenderServer.writeLine("Capturing...");
											Bitmap bitmap9 = new Bitmap(921, 921);
											Point point5 = new Point(965, 521);
											Point point6 = new Point(995, 519);
											Graphics graphics14 = Graphics.FromImage(bitmap9);
											Graphics graphics15 = graphics14;
											Point upperLeftSource = new Point(rectangle.Left + 500, rectangle.Top + 85);
											graphics15.CopyFromScreen(upperLeftSource, Point.Empty, bitmap9.Size);
											bitmap9.MakeTransparent(Color.FromArgb(75, 254, 0));
											bitmap9.MakeTransparent(Color.FromArgb(75, 255, 0));
											bitmap9.MakeTransparent(Color.FromArgb(82, 255, 0));
											bitmap9.MakeTransparent(Color.FromArgb(0, 255, 1));
											Image image16 = bitmap9;
											Size size = new Size(120, 120);
											Image image17 = RenderServer.ResizeImage(image16, size, true);
											image17.Save(text16 + Conversions.ToString(value5) + ".png");
											process6.Kill();
											RenderServer.writeLine("Uploading..");
											MyProject.Computer.Network.UploadFile(text16 + Conversions.ToString(value5) + ".png", text9 + "/goodblox/api/scripts/render_server/uploadTheRenderersOk.php?password=1pVoBfdx3PcgGZKR&queueid=" + array2[1]);
											RenderServer.writeLine("Done!");
											MyProject.Computer.FileSystem.RenameFile(text16 + Conversions.ToString(value5) + ".png", Conversions.ToString(value5) + "_" + DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt") + ".png");
										}
										else
										{
											flag = (Operators.CompareString(array2[0], "4", false) == 0);
											if (flag)
											{
												RenderServer.writeLine("Rendering place (placeID : " + array2[2] + ")");
												int value6 = Conversions.ToInteger(array2[2]);
												string text17 = Application.StartupPath + "\\" + Conversions.ToString(value6) + ".rbxl";
												string text18 = Application.StartupPath + "\\placeRenders\\" + Conversions.ToString(value6);
												flag = !Directory.Exists(text18);
												if (flag)
												{
													Directory.CreateDirectory(text18);
												}
												flag = File.Exists(text17);
												if (flag)
												{
													RenderServer.writeLine("Deleting existing place..");
													File.Delete(text17);
												}
												RenderServer.writeLine("Downloading place from storage server..");
												MyProject.Computer.Network.DownloadFile(str + "/places/" + Conversions.ToString(value6) + ".rbxl", text17, userName, password);
												RenderServer.writeLine("Changing sky..");
												MyProject.Computer.FileSystem.RenameDirectory(Application.StartupPath + "\\Render\\content\\sky", "sky2");
												MyProject.Computer.FileSystem.RenameDirectory(Application.StartupPath + "\\Render\\content\\sky1", "sky");
												RenderServer.SetCursorPos(0, 0);
												Process process7 = Process.Start(Application.StartupPath + "\\Render\\GBRender.exe", string.Concat(new string[]
												{
													"\"",
													text17,
													"\" -script \"",
													text9.Replace("https://", "http://"),
													"/goodblox/api/scripts/removeGears.lua\""
												}));
												RenderServer.writeLine("Sleeping " + Conversions.ToString((double)num3 / 1000.0) + " seconds..");
												Thread.Sleep(num3);
												RenderServer.FocusWindow("Roblox - [" + Conversions.ToString(value6) + ".rbxl]", null);
												RenderServer.BringMainWindowToFront("Render");
												Bitmap bitmap10 = new Bitmap(1440, 900);
												Graphics graphics16 = Graphics.FromImage(bitmap10);
												Graphics graphics17 = graphics16;
												Point upperLeftSource = new Point(rectangle.Left + 50, rectangle.Top + 100);
												graphics17.CopyFromScreen(upperLeftSource, Point.Empty, bitmap10.Size);
												bitmap10.MakeTransparent(Color.FromArgb(75, 254, 0));
												bitmap10.MakeTransparent(Color.FromArgb(75, 255, 0));
												bitmap10.MakeTransparent(Color.FromArgb(82, 255, 0));
												bitmap10.MakeTransparent(Color.FromArgb(0, 255, 1));
												Image image18 = bitmap10;
												Size size = new Size(720, 450);
												Image image19 = RenderServer.ResizeImage(image18, size, true);
												image19.Save(text18 + Conversions.ToString(value6) + "-large.png", ImageFormat.Png);
												Image image20 = bitmap10;
												size = new Size(160, 100);
												Image image21 = RenderServer.ResizeImage(image20, size, true);
												image21.Save(text18 + Conversions.ToString(value6) + "-small.png", ImageFormat.Png);
												Image image22 = bitmap10;
												size = new Size(420, 230);
												Image image23 = RenderServer.ResizeImage(image22, size, false);
												image23.Save(text18 + Conversions.ToString(value6) + ".png", ImageFormat.Png);
												Image image24 = bitmap10;
												size = new Size(1440, 900);
												Image image25 = RenderServer.ResizeImage(image24, size, true);
												image25.Save(text18 + Conversions.ToString(value6) + "-xlarge.png", ImageFormat.Png);
												process7.Kill();
												RenderServer.writeLine("Rechanging sky..");
												MyProject.Computer.FileSystem.RenameDirectory(Application.StartupPath + "\\Render\\content\\sky", "sky1");
												MyProject.Computer.FileSystem.RenameDirectory(Application.StartupPath + "\\Render\\content\\sky2", "sky");
												RenderServer.writeLine("Uploading..");
												FileStream fileStream5 = File.Open(text18 + Conversions.ToString(value6) + "-large.png", FileMode.Open);
												FileStream fileStream6 = File.Open(text18 + Conversions.ToString(value6) + "-small.png", FileMode.Open);
												FileStream fileStream7 = File.Open(text18 + Conversions.ToString(value6) + ".png", FileMode.Open);
												FileStream fileStream8 = File.Open(text18 + Conversions.ToString(value6) + "-xlarge.png", FileMode.Open);
												RenderServer.UploadAsync(text9 + "/goodblox/api/scripts/render_server/uploadTheRenderersOk.php?password=1pVoBfdx3PcgGZKR&queueid=" + array2[1], fileStream5, fileStream6, 2, fileStream7, fileStream8);
												fileStream5.Dispose();
												fileStream6.Dispose();
												fileStream7.Dispose();
												fileStream8.Dispose();
												RenderServer.writeLine("Done!");
												MyProject.Computer.FileSystem.RenameFile(text18 + Conversions.ToString(value6) + ".png", Conversions.ToString(value6) + "_" + DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt") + ".png");
												MyProject.Computer.FileSystem.RenameFile(text18 + Conversions.ToString(value6) + "-small.png", Conversions.ToString(value6) + "-small_" + DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt") + ".png");
												MyProject.Computer.FileSystem.RenameFile(text18 + Conversions.ToString(value6) + "-large.png", Conversions.ToString(value6) + "-large_" + DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt") + ".png");
												MyProject.Computer.FileSystem.RenameFile(text18 + Conversions.ToString(value6) + "-xlarge.png", Conversions.ToString(value6) + "-xlarge_" + DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt") + ".png");
												File.Delete(Conversions.ToString(value6) + ".rbxl");
											}
											else
											{
												flag = (Operators.CompareString(array2[0], "nan", false) == 0);
												if (flag)
												{
													RenderServer.writeLine("Nothing to render..");
													Thread.Sleep(millisecondsTimeout);
													num7++;
													flag = (num7 == num4 | num7 > num4);
													if (flag)
													{
														break;
													}
												}
												else
												{
													RenderServer.writeLine("Received message.");
													RenderServer.writeLine(array2[0]);
													Thread.Sleep(millisecondsTimeout);
													flag = (Operators.CompareString(array2[1], "End", false) == 0);
													if (flag)
													{
														ProjectData.EndApp();
													}
													else
													{
														num7++;
														flag = (num7 == num4 | num7 > num4);
														if (flag)
														{
															break;
														}
													}
												}
											}
										}
									}
								}
							}
							continue;
						}
						catch (WebException ex4)
						{
							Process[] processesByName = Process.GetProcessesByName("GBRender");
							foreach (Process process8 in processesByName)
							{
								process8.Kill();
							}
							RenderServer.writeLine("Exception occured.");
							RenderServer.writeLine("");
							RenderServer.writeLine(ex4);
							RenderServer.writeLine("");
							RenderServer.writeLine("Restarting program in 5 seconds. More exception information will be stored in renderapp_exception_" + DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt") + ".txt");
							Thread.Sleep(5000);
							string contents = string.Concat(new string[]
							{
								"--- [ Exception Information On ",
								DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt"),
								" ] ---\r\nMessage: ",
								ex4.Message,
								"\r\n\r\nStack Trace:\r\n",
								ex4.StackTrace,
								"\r\n\r\nSource:\r\n",
								ex4.Source,
								"\r\n\r\nMore Data:\r\n",
								ex4.ToString()
							});
							flag = !Directory.Exists(Application.StartupPath + "\\RenderExceptions");
							if (flag)
							{
								Directory.CreateDirectory(Application.StartupPath + "\\RenderExceptions");
							}
							File.WriteAllText(Application.StartupPath + "\\RenderExceptions\\renderapp_exception_" + DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt") + ".txt", contents);
							Application.Restart();
						}
						return;
					}
				}
			}
		}

		// Token: 0x06000023 RID: 35 RVA: 0x00196550 File Offset: 0x00194950
		[MethodImpl(MethodImplOptions.NoInlining | MethodImplOptions.NoOptimization)]
		public static void kill(object str)
		{
			RenderServer.writeLine(RuntimeHelpers.GetObjectValue(str));
			RenderServer.writeLine("Press any key to exit.");
			Console.ReadKey();
			ProjectData.EndApp();
		}

		// Token: 0x06000024 RID: 36 RVA: 0x00196578 File Offset: 0x00194978
		public static void writeLine(object str = "")
		{
			Console.WriteLine(RuntimeHelpers.GetObjectValue(str));
			RenderServer.consoleFile = RenderServer.consoleFile + str.ToString() + Environment.NewLine;
			checked
			{
				RenderServer.timesWrittenTo++;
				bool flag = RenderServer.timesWrittenTo == RenderServer.consoleLines | RenderServer.timesWrittenTo > RenderServer.consoleLines;
				if (flag)
				{
					string contents = "--- [ Log file from " + DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt") + " ] ---\r\n" + RenderServer.consoleFile;
					flag = !Directory.Exists(Application.StartupPath + "\\Logs");
					if (flag)
					{
						Directory.CreateDirectory(Application.StartupPath + "\\Logs");
					}
					File.WriteAllText(Application.StartupPath + "\\Logs\\log" + DateTime.Parse(Conversions.ToString(DateTime.Now)).ToString("dd_MM_yyyy_hh_mm_ss_tt") + ".txt", contents);
					RenderServer.timesWrittenTo = 0;
					Console.Clear();
				}
			}
		}

		// Token: 0x06000025 RID: 37 RVA: 0x00196688 File Offset: 0x00194A88
		private static object UploadAsync(string url, Stream avv1, Stream avv2, int Type, Stream avv3 = null, Stream avv4 = null)
		{
			HttpContent content = new StreamContent(avv1);
			HttpContent content2 = new StreamContent(avv2);
			HttpClient httpClient = new HttpClient();
			MultipartFormDataContent multipartFormDataContent = new MultipartFormDataContent();
			bool flag = Type == 0;
			if (flag)
			{
				multipartFormDataContent.Add(content, "av1", "filename");
				multipartFormDataContent.Add(content2, "av2", "filename");
			}
			else
			{
				flag = (Type == 1);
				if (flag)
				{
					multipartFormDataContent.Add(content, "av1", "filename");
					multipartFormDataContent.Add(content2, "av2", "filename");
				}
				else
				{
					flag = (Type == 2);
					if (flag)
					{
						HttpContent content3 = new StreamContent(avv3);
						HttpContent content4 = new StreamContent(avv4);
						multipartFormDataContent.Add(content, "av1", "filename");
						multipartFormDataContent.Add(content2, "av2", "filename");
						multipartFormDataContent.Add(content3, "av3", "filename");
						multipartFormDataContent.Add(content4, "av4", "filename");
					}
				}
			}
			HttpResponseMessage result = httpClient.PostAsync(url, multipartFormDataContent).Result;
			flag = result.IsSuccessStatusCode;
			object result2;
			if (flag)
			{
				result2 = true;
			}
			else
			{
				result2 = false;
			}
			return result2;
		}

		// Token: 0x06000026 RID: 38 RVA: 0x001967B0 File Offset: 0x00194BB0
		public static void ImageModelServerView()
		{
			RenderServer.Crap();
			Thread.Sleep(1000);
			RenderServer.SetCursorPos(0, 0);
			RenderServer.Crap();
		}

		// Token: 0x06000027 RID: 39
		[DllImport("user32", CharSet = CharSet.Auto, SetLastError = true)]
		public static extern long SetCursorPos(int X, int Y);

		// Token: 0x06000028 RID: 40
		[DllImport("user32", CharSet = CharSet.Ansi, ExactSpelling = true, SetLastError = true)]
		public static extern void mouse_event(int dwFlags, int dx, int dy, int cButtons, int dwExtraInfo);

		// Token: 0x06000029 RID: 41 RVA: 0x001967D4 File Offset: 0x00194BD4
		private static void Crap()
		{
			RenderServer.SetCursorPos(0, 0);
			RenderServer.SetCursorPos(242, 30);
			RenderServer.mouse_event(2, 0, 0, 0, 1);
			RenderServer.mouse_event(4, 0, 0, 0, 1);
			Thread.Sleep(500);
			RenderServer.SetCursorPos(303, 215);
			RenderServer.mouse_event(2, 0, 0, 0, 1);
			RenderServer.mouse_event(4, 0, 0, 0, 1);
			Thread.Sleep(500);
			RenderServer.SetCursorPos(0, 0);
		}

		// Token: 0x0600002A RID: 42
		[DllImport("user32.dll")]
		private static extern bool ShowWindow(IntPtr hWnd, RenderServer.ShowWindowEnum flags);

		// Token: 0x0600002B RID: 43
		[DllImport("user32.dll")]
		private static extern int SetForegroundWindow(IntPtr hwnd);

		// Token: 0x0600002C RID: 44 RVA: 0x00196854 File Offset: 0x00194C54
		public static object BringMainWindowToFront(string processName)
		{
			Process process = Process.GetProcessesByName(processName).FirstOrDefault<Process>();
			bool flag = process != null;
			object result;
			if (flag)
			{
				bool flag2 = process.MainWindowHandle == IntPtr.Zero;
				if (flag2)
				{
					RenderServer.ShowWindow(process.Handle, RenderServer.ShowWindowEnum.Restore);
				}
				RenderServer.SetForegroundWindow(process.MainWindowHandle);
				RenderServer.writeLine("Focused window");
				result = true;
			}
			else
			{
				RenderServer.writeLine("Window not found. Retrying..");
				result = false;
			}
			return result;
		}

		// Token: 0x0600002D RID: 45
		[DllImport("user32.dll", CharSet = CharSet.Ansi, ExactSpelling = true, SetLastError = true)]
		public static extern bool IsIconic(int hwnd);

		// Token: 0x0600002E RID: 46
		[DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
		public static extern int FindWindow([MarshalAs(UnmanagedType.VBByRefStr)] ref string lpClassName, [MarshalAs(UnmanagedType.VBByRefStr)] ref string lpWindowName);

		// Token: 0x0600002F RID: 47 RVA: 0x001968D8 File Offset: 0x00194CD8
		public static void FocusWindow(string strWindowCaption, string strClassName)
		{
			int num = RenderServer.FindWindow(ref strClassName, ref strWindowCaption);
			bool flag = num > 0;
			if (flag)
			{
				RenderServer.SetForegroundWindow((IntPtr)num);
				flag = RenderServer.IsIconic(num);
				if (flag)
				{
					RenderServer.ShowWindow((IntPtr)num, RenderServer.ShowWindowEnum.Restore);
				}
				else
				{
					RenderServer.ShowWindow((IntPtr)num, RenderServer.ShowWindowEnum.Show);
				}
			}
		}

		// Token: 0x04000009 RID: 9
		private static int timesWrittenTo = 4;

		// Token: 0x0400000A RID: 10
		private static bool rendererLoaded = false;

		// Token: 0x0400000B RID: 11
		private static string consoleFile;

		// Token: 0x0400000C RID: 12
		private static int consoleLines = 1000;

		// Token: 0x0400000D RID: 13
		public const int SW_RESTORE = 9;

		// Token: 0x0400000E RID: 14
		public const int SW_SHOW = 5;

		// Token: 0x0200000A RID: 10
		private enum ShowWindowEnum
		{
			// Token: 0x04000010 RID: 16
			Hide,
			// Token: 0x04000011 RID: 17
			ShowNormal,
			// Token: 0x04000012 RID: 18
			ShowMinimized,
			// Token: 0x04000013 RID: 19
			ShowMaximized,
			// Token: 0x04000014 RID: 20
			Maximize = 3,
			// Token: 0x04000015 RID: 21
			ShowNormalNoActivate,
			// Token: 0x04000016 RID: 22
			Show,
			// Token: 0x04000017 RID: 23
			Minimize,
			// Token: 0x04000018 RID: 24
			ShowMinNoActivate,
			// Token: 0x04000019 RID: 25
			ShowNoActivate,
			// Token: 0x0400001A RID: 26
			Restore,
			// Token: 0x0400001B RID: 27
			ShowDefault,
			// Token: 0x0400001C RID: 28
			ForceMinimized
		}
	}
}
